"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _stringLength = _interopRequireDefault(require("string-length"));

var _sliceAnsi = _interopRequireDefault(require("slice-ansi"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Output {
  constructor({
    height
  }) {
    this.output = new Array(height);
  }

  write(x, y, text, {
    transformers
  }) {
    const lines = text.split('\n');
    let offsetY = 0;

    for (const line of lines) {
      const length = (0, _stringLength.default)(line);

      for (let offsetX = 0; offsetX < length; offsetX++) {
        if (!Array.isArray(this.output[y + offsetY])) {
          this.output[y + offsetY] = [];
        }

        let char = (0, _sliceAnsi.default)(line, offsetX, offsetX + 1);

        for (const transformer of transformers) {
          char = transformer(char);
        }

        this.output[y + offsetY][x + offsetX] = char;
      }

      offsetY++;
    }
  }

  get() {
    let ret = '';

    for (let y = 0; y < this.output.length; y++) {
      if (this.output[y]) {
        for (let x = 0; x < this.output[y].length; x++) {
          ret += this.output[y][x] || ' ';
        }
      }

      ret += '\n';
    }

    return ret;
  }

}

exports.default = Output;